"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The AutomationTokenCreateRequestAttributes model module.
 * @module model/AutomationTokenCreateRequestAttributes
 * @version 7.0.0
 */
var AutomationTokenCreateRequestAttributes = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>AutomationTokenCreateRequestAttributes</code>.
   * @alias module:model/AutomationTokenCreateRequestAttributes
   */
  function AutomationTokenCreateRequestAttributes() {
    _classCallCheck(this, AutomationTokenCreateRequestAttributes);
    AutomationTokenCreateRequestAttributes.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(AutomationTokenCreateRequestAttributes, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>AutomationTokenCreateRequestAttributes</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/AutomationTokenCreateRequestAttributes} obj Optional instance to populate.
     * @return {module:model/AutomationTokenCreateRequestAttributes} The populated <code>AutomationTokenCreateRequestAttributes</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new AutomationTokenCreateRequestAttributes();
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('role')) {
          obj['role'] = _ApiClient["default"].convertToType(data['role'], 'String');
        }
        if (data.hasOwnProperty('services')) {
          obj['services'] = _ApiClient["default"].convertToType(data['services'], ['String']);
        }
        if (data.hasOwnProperty('scope')) {
          obj['scope'] = _ApiClient["default"].convertToType(data['scope'], 'String');
        }
        if (data.hasOwnProperty('expires_at')) {
          obj['expires_at'] = _ApiClient["default"].convertToType(data['expires_at'], 'Date');
        }
        if (data.hasOwnProperty('tls_access')) {
          obj['tls_access'] = _ApiClient["default"].convertToType(data['tls_access'], 'Boolean');
        }
      }
      return obj;
    }
  }]);
  return AutomationTokenCreateRequestAttributes;
}();
/**
 * name of the token
 * @member {String} name
 */
AutomationTokenCreateRequestAttributes.prototype['name'] = undefined;

/**
 * @member {module:model/AutomationTokenCreateRequestAttributes.RoleEnum} role
 */
AutomationTokenCreateRequestAttributes.prototype['role'] = undefined;

/**
 * List of service ids to limit the token
 * @member {Array.<String>} services
 */
AutomationTokenCreateRequestAttributes.prototype['services'] = undefined;

/**
 * @member {module:model/AutomationTokenCreateRequestAttributes.ScopeEnum} scope
 * @default 'global'
 */
AutomationTokenCreateRequestAttributes.prototype['scope'] = undefined;

/**
 * A UTC time-stamp of when the token will expire.
 * @member {Date} expires_at
 */
AutomationTokenCreateRequestAttributes.prototype['expires_at'] = undefined;

/**
 * Indicates whether TLS access is enabled for the token.
 * @member {Boolean} tls_access
 */
AutomationTokenCreateRequestAttributes.prototype['tls_access'] = undefined;

/**
 * Allowed values for the <code>role</code> property.
 * @enum {String}
 * @readonly
 */
AutomationTokenCreateRequestAttributes['RoleEnum'] = {
  /**
   * value: "engineer"
   * @const
   */
  "engineer": "engineer",
  /**
   * value: "billing"
   * @const
   */
  "billing": "billing",
  /**
   * value: "user"
   * @const
   */
  "user": "user"
};

/**
 * Allowed values for the <code>scope</code> property.
 * @enum {String}
 * @readonly
 */
AutomationTokenCreateRequestAttributes['ScopeEnum'] = {
  /**
   * value: "global"
   * @const
   */
  "global": "global",
  /**
   * value: "global:read"
   * @const
   */
  "global:read": "global:read",
  /**
   * value: "purge_all"
   * @const
   */
  "purge_all": "purge_all",
  /**
   * value: "purge_select"
   * @const
   */
  "purge_select": "purge_select"
};
var _default = AutomationTokenCreateRequestAttributes;
exports["default"] = _default;