"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _AutomationToken = _interopRequireDefault(require("./AutomationToken"));
var _AutomationTokenCreateResponseAllOf = _interopRequireDefault(require("./AutomationTokenCreateResponseAllOf"));
var _ReadOnlyCustomerId = _interopRequireDefault(require("./ReadOnlyCustomerId"));
var _ReadOnlyId = _interopRequireDefault(require("./ReadOnlyId"));
var _ReadOnlyUserId = _interopRequireDefault(require("./ReadOnlyUserId"));
var _Timestamps = _interopRequireDefault(require("./Timestamps"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The AutomationTokenCreateResponse model module.
 * @module model/AutomationTokenCreateResponse
 * @version 7.0.0
 */
var AutomationTokenCreateResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>AutomationTokenCreateResponse</code>.
   * @alias module:model/AutomationTokenCreateResponse
   * @implements module:model/AutomationToken
   * @implements module:model/Timestamps
   * @implements module:model/AutomationTokenCreateResponseAllOf
   */
  function AutomationTokenCreateResponse() {
    _classCallCheck(this, AutomationTokenCreateResponse);
    _AutomationToken["default"].initialize(this);
    _Timestamps["default"].initialize(this);
    _AutomationTokenCreateResponseAllOf["default"].initialize(this);
    AutomationTokenCreateResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(AutomationTokenCreateResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>AutomationTokenCreateResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/AutomationTokenCreateResponse} obj Optional instance to populate.
     * @return {module:model/AutomationTokenCreateResponse} The populated <code>AutomationTokenCreateResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new AutomationTokenCreateResponse();
        _AutomationToken["default"].constructFromObject(data, obj);
        _Timestamps["default"].constructFromObject(data, obj);
        _AutomationTokenCreateResponseAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('role')) {
          obj['role'] = _ApiClient["default"].convertToType(data['role'], 'String');
        }
        if (data.hasOwnProperty('services')) {
          obj['services'] = _ApiClient["default"].convertToType(data['services'], ['String']);
        }
        if (data.hasOwnProperty('scope')) {
          obj['scope'] = _ApiClient["default"].convertToType(data['scope'], 'String');
        }
        if (data.hasOwnProperty('expires_at')) {
          obj['expires_at'] = _ApiClient["default"].convertToType(data['expires_at'], 'String');
        }
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }
        if (data.hasOwnProperty('deleted_at')) {
          obj['deleted_at'] = _ApiClient["default"].convertToType(data['deleted_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ReadOnlyId["default"].constructFromObject(data['id']);
        }
        if (data.hasOwnProperty('user_id')) {
          obj['user_id'] = _ReadOnlyUserId["default"].constructFromObject(data['user_id']);
        }
        if (data.hasOwnProperty('customer_id')) {
          obj['customer_id'] = _ReadOnlyCustomerId["default"].constructFromObject(data['customer_id']);
        }
        if (data.hasOwnProperty('sudo_expires_at')) {
          obj['sudo_expires_at'] = _ApiClient["default"].convertToType(data['sudo_expires_at'], 'Date');
        }
        if (data.hasOwnProperty('access_token')) {
          obj['access_token'] = _ApiClient["default"].convertToType(data['access_token'], 'String');
        }
        if (data.hasOwnProperty('last_used_at')) {
          obj['last_used_at'] = _ApiClient["default"].convertToType(data['last_used_at'], 'Date');
        }
        if (data.hasOwnProperty('user_agent')) {
          obj['user_agent'] = _ApiClient["default"].convertToType(data['user_agent'], 'String');
        }
      }
      return obj;
    }
  }]);
  return AutomationTokenCreateResponse;
}();
/**
 * The name of the token.
 * @member {String} name
 */
AutomationTokenCreateResponse.prototype['name'] = undefined;

/**
 * The role on the token.
 * @member {module:model/AutomationTokenCreateResponse.RoleEnum} role
 */
AutomationTokenCreateResponse.prototype['role'] = undefined;

/**
 * (Optional) The service IDs of the services the token will have access to. Separate service IDs with a space. If no services are specified, the token will have access to all services on the account. 
 * @member {Array.<String>} services
 */
AutomationTokenCreateResponse.prototype['services'] = undefined;

/**
 * A space-delimited list of authorization scope.
 * @member {module:model/AutomationTokenCreateResponse.ScopeEnum} scope
 * @default 'global'
 */
AutomationTokenCreateResponse.prototype['scope'] = undefined;

/**
 * A UTC time-stamp of when the token expires.
 * @member {String} expires_at
 */
AutomationTokenCreateResponse.prototype['expires_at'] = undefined;

/**
 * A UTC time-stamp of when the token was created. 
 * @member {Date} created_at
 */
AutomationTokenCreateResponse.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
AutomationTokenCreateResponse.prototype['deleted_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
AutomationTokenCreateResponse.prototype['updated_at'] = undefined;

/**
 * @member {module:model/ReadOnlyId} id
 */
AutomationTokenCreateResponse.prototype['id'] = undefined;

/**
 * @member {module:model/ReadOnlyUserId} user_id
 */
AutomationTokenCreateResponse.prototype['user_id'] = undefined;

/**
 * @member {module:model/ReadOnlyCustomerId} customer_id
 */
AutomationTokenCreateResponse.prototype['customer_id'] = undefined;

/**
 * @member {Date} sudo_expires_at
 */
AutomationTokenCreateResponse.prototype['sudo_expires_at'] = undefined;

/**
 * @member {String} access_token
 */
AutomationTokenCreateResponse.prototype['access_token'] = undefined;

/**
 * A UTC time-stamp of when the token was last used.
 * @member {Date} last_used_at
 */
AutomationTokenCreateResponse.prototype['last_used_at'] = undefined;

/**
 * The User-Agent header of the client that last used the token.
 * @member {String} user_agent
 */
AutomationTokenCreateResponse.prototype['user_agent'] = undefined;

// Implement AutomationToken interface:
/**
 * The name of the token.
 * @member {String} name
 */
_AutomationToken["default"].prototype['name'] = undefined;
/**
 * The role on the token.
 * @member {module:model/AutomationToken.RoleEnum} role
 */
_AutomationToken["default"].prototype['role'] = undefined;
/**
 * (Optional) The service IDs of the services the token will have access to. Separate service IDs with a space. If no services are specified, the token will have access to all services on the account. 
 * @member {Array.<String>} services
 */
_AutomationToken["default"].prototype['services'] = undefined;
/**
 * A space-delimited list of authorization scope.
 * @member {module:model/AutomationToken.ScopeEnum} scope
 * @default 'global'
 */
_AutomationToken["default"].prototype['scope'] = undefined;
/**
 * A UTC time-stamp of when the token expires.
 * @member {String} expires_at
 */
_AutomationToken["default"].prototype['expires_at'] = undefined;
// Implement Timestamps interface:
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
_Timestamps["default"].prototype['created_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
_Timestamps["default"].prototype['deleted_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
_Timestamps["default"].prototype['updated_at'] = undefined;
// Implement AutomationTokenCreateResponseAllOf interface:
/**
 * @member {module:model/ReadOnlyId} id
 */
_AutomationTokenCreateResponseAllOf["default"].prototype['id'] = undefined;
/**
 * @member {module:model/ReadOnlyUserId} user_id
 */
_AutomationTokenCreateResponseAllOf["default"].prototype['user_id'] = undefined;
/**
 * @member {module:model/ReadOnlyCustomerId} customer_id
 */
_AutomationTokenCreateResponseAllOf["default"].prototype['customer_id'] = undefined;
/**
 * @member {Date} sudo_expires_at
 */
_AutomationTokenCreateResponseAllOf["default"].prototype['sudo_expires_at'] = undefined;
/**
 * A UTC time-stamp of when the token was created. 
 * @member {Date} created_at
 */
_AutomationTokenCreateResponseAllOf["default"].prototype['created_at'] = undefined;
/**
 * @member {String} access_token
 */
_AutomationTokenCreateResponseAllOf["default"].prototype['access_token'] = undefined;
/**
 * A UTC time-stamp of when the token was last used.
 * @member {Date} last_used_at
 */
_AutomationTokenCreateResponseAllOf["default"].prototype['last_used_at'] = undefined;
/**
 * The User-Agent header of the client that last used the token.
 * @member {String} user_agent
 */
_AutomationTokenCreateResponseAllOf["default"].prototype['user_agent'] = undefined;

/**
 * Allowed values for the <code>role</code> property.
 * @enum {String}
 * @readonly
 */
AutomationTokenCreateResponse['RoleEnum'] = {
  /**
   * value: "billing"
   * @const
   */
  "billing": "billing",
  /**
   * value: "engineer"
   * @const
   */
  "engineer": "engineer",
  /**
   * value: "user"
   * @const
   */
  "user": "user"
};

/**
 * Allowed values for the <code>scope</code> property.
 * @enum {String}
 * @readonly
 */
AutomationTokenCreateResponse['ScopeEnum'] = {
  /**
   * value: "global"
   * @const
   */
  "global": "global",
  /**
   * value: "purge_select"
   * @const
   */
  "purge_select": "purge_select",
  /**
   * value: "purge_all"
   * @const
   */
  "purge_all": "purge_all",
  /**
   * value: "global:read"
   * @const
   */
  "global:read": "global:read"
};
var _default = AutomationTokenCreateResponse;
exports["default"] = _default;