"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _ReadOnlyCustomerId = _interopRequireDefault(require("./ReadOnlyCustomerId"));
var _ReadOnlyId = _interopRequireDefault(require("./ReadOnlyId"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The AutomationTokenResponseAllOf model module.
 * @module model/AutomationTokenResponseAllOf
 * @version 7.0.0
 */
var AutomationTokenResponseAllOf = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>AutomationTokenResponseAllOf</code>.
   * @alias module:model/AutomationTokenResponseAllOf
   */
  function AutomationTokenResponseAllOf() {
    _classCallCheck(this, AutomationTokenResponseAllOf);
    AutomationTokenResponseAllOf.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(AutomationTokenResponseAllOf, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>AutomationTokenResponseAllOf</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/AutomationTokenResponseAllOf} obj Optional instance to populate.
     * @return {module:model/AutomationTokenResponseAllOf} The populated <code>AutomationTokenResponseAllOf</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new AutomationTokenResponseAllOf();
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ReadOnlyId["default"].constructFromObject(data['id']);
        }
        if (data.hasOwnProperty('customer_id')) {
          obj['customer_id'] = _ReadOnlyCustomerId["default"].constructFromObject(data['customer_id']);
        }
        if (data.hasOwnProperty('role')) {
          obj['role'] = _ApiClient["default"].convertToType(data['role'], 'String');
        }
        if (data.hasOwnProperty('ip')) {
          obj['ip'] = _ApiClient["default"].convertToType(data['ip'], 'String');
        }
        if (data.hasOwnProperty('user_agent')) {
          obj['user_agent'] = _ApiClient["default"].convertToType(data['user_agent'], 'String');
        }
        if (data.hasOwnProperty('sudo_expires_at')) {
          obj['sudo_expires_at'] = _ApiClient["default"].convertToType(data['sudo_expires_at'], 'String');
        }
        if (data.hasOwnProperty('last_used_at')) {
          obj['last_used_at'] = _ApiClient["default"].convertToType(data['last_used_at'], 'Date');
        }
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'String');
        }
        if (data.hasOwnProperty('expires_at')) {
          obj['expires_at'] = _ApiClient["default"].convertToType(data['expires_at'], 'String');
        }
      }
      return obj;
    }
  }]);
  return AutomationTokenResponseAllOf;
}();
/**
 * @member {module:model/ReadOnlyId} id
 */
AutomationTokenResponseAllOf.prototype['id'] = undefined;

/**
 * @member {module:model/ReadOnlyCustomerId} customer_id
 */
AutomationTokenResponseAllOf.prototype['customer_id'] = undefined;

/**
 * @member {String} role
 */
AutomationTokenResponseAllOf.prototype['role'] = undefined;

/**
 * The IP address of the client that last used the token.
 * @member {String} ip
 */
AutomationTokenResponseAllOf.prototype['ip'] = undefined;

/**
 * The User-Agent header of the client that last used the token.
 * @member {String} user_agent
 */
AutomationTokenResponseAllOf.prototype['user_agent'] = undefined;

/**
 * @member {String} sudo_expires_at
 */
AutomationTokenResponseAllOf.prototype['sudo_expires_at'] = undefined;

/**
 * A UTC time-stamp of when the token was last used.
 * @member {Date} last_used_at
 */
AutomationTokenResponseAllOf.prototype['last_used_at'] = undefined;

/**
 * A UTC time-stamp of when the token was created.
 * @member {String} created_at
 */
AutomationTokenResponseAllOf.prototype['created_at'] = undefined;

/**
 * (optional) A UTC time-stamp of when the token will expire.
 * @member {String} expires_at
 */
AutomationTokenResponseAllOf.prototype['expires_at'] = undefined;
var _default = AutomationTokenResponseAllOf;
exports["default"] = _default;