"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _AclEntry = _interopRequireDefault(require("./AclEntry"));
var _BulkUpdateAclEntryAllOf = _interopRequireDefault(require("./BulkUpdateAclEntryAllOf"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The BulkUpdateAclEntry model module.
 * @module model/BulkUpdateAclEntry
 * @version 7.0.0
 */
var BulkUpdateAclEntry = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>BulkUpdateAclEntry</code>.
   * @alias module:model/BulkUpdateAclEntry
   * @implements module:model/AclEntry
   * @implements module:model/BulkUpdateAclEntryAllOf
   */
  function BulkUpdateAclEntry() {
    _classCallCheck(this, BulkUpdateAclEntry);
    _AclEntry["default"].initialize(this);
    _BulkUpdateAclEntryAllOf["default"].initialize(this);
    BulkUpdateAclEntry.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(BulkUpdateAclEntry, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>BulkUpdateAclEntry</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/BulkUpdateAclEntry} obj Optional instance to populate.
     * @return {module:model/BulkUpdateAclEntry} The populated <code>BulkUpdateAclEntry</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new BulkUpdateAclEntry();
        _AclEntry["default"].constructFromObject(data, obj);
        _BulkUpdateAclEntryAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('negated')) {
          obj['negated'] = _ApiClient["default"].convertToType(data['negated'], 'Number');
        }
        if (data.hasOwnProperty('comment')) {
          obj['comment'] = _ApiClient["default"].convertToType(data['comment'], 'String');
        }
        if (data.hasOwnProperty('ip')) {
          obj['ip'] = _ApiClient["default"].convertToType(data['ip'], 'String');
        }
        if (data.hasOwnProperty('subnet')) {
          obj['subnet'] = _ApiClient["default"].convertToType(data['subnet'], 'Number');
        }
        if (data.hasOwnProperty('op')) {
          obj['op'] = _ApiClient["default"].convertToType(data['op'], 'String');
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
      }
      return obj;
    }
  }]);
  return BulkUpdateAclEntry;
}();
/**
 * Whether to negate the match. Useful primarily when creating individual exceptions to larger subnets.
 * @member {module:model/BulkUpdateAclEntry.NegatedEnum} negated
 * @default NegatedEnum.disable
 */
BulkUpdateAclEntry.prototype['negated'] = undefined;

/**
 * A freeform descriptive note.
 * @member {String} comment
 */
BulkUpdateAclEntry.prototype['comment'] = undefined;

/**
 * An IP address.
 * @member {String} ip
 */
BulkUpdateAclEntry.prototype['ip'] = undefined;

/**
 * Number of bits for the subnet mask applied to the IP address. For IPv4 addresses, a value of 32 represents the smallest subnet mask (1 address), 24 represents a class C subnet mask (256 addresses), 16 represents a class B subnet mask (65k addresses), and 8 is class A subnet mask (16m addresses). If not provided, no mask is applied.
 * @member {Number} subnet
 */
BulkUpdateAclEntry.prototype['subnet'] = undefined;

/**
 * @member {module:model/BulkUpdateAclEntry.OpEnum} op
 */
BulkUpdateAclEntry.prototype['op'] = undefined;

/**
 * @member {String} id
 */
BulkUpdateAclEntry.prototype['id'] = undefined;

// Implement AclEntry interface:
/**
 * Whether to negate the match. Useful primarily when creating individual exceptions to larger subnets.
 * @member {module:model/AclEntry.NegatedEnum} negated
 * @default NegatedEnum.disable
 */
_AclEntry["default"].prototype['negated'] = undefined;
/**
 * A freeform descriptive note.
 * @member {String} comment
 */
_AclEntry["default"].prototype['comment'] = undefined;
/**
 * An IP address.
 * @member {String} ip
 */
_AclEntry["default"].prototype['ip'] = undefined;
/**
 * Number of bits for the subnet mask applied to the IP address. For IPv4 addresses, a value of 32 represents the smallest subnet mask (1 address), 24 represents a class C subnet mask (256 addresses), 16 represents a class B subnet mask (65k addresses), and 8 is class A subnet mask (16m addresses). If not provided, no mask is applied.
 * @member {Number} subnet
 */
_AclEntry["default"].prototype['subnet'] = undefined;
// Implement BulkUpdateAclEntryAllOf interface:
/**
 * @member {module:model/BulkUpdateAclEntryAllOf.OpEnum} op
 */
_BulkUpdateAclEntryAllOf["default"].prototype['op'] = undefined;
/**
 * @member {String} id
 */
_BulkUpdateAclEntryAllOf["default"].prototype['id'] = undefined;

/**
 * Allowed values for the <code>negated</code> property.
 * @enum {Number}
 * @readonly
 */
BulkUpdateAclEntry['NegatedEnum'] = {
  /**
   * value: 0
   * @const
   */
  "disable": 0,
  /**
   * value: 1
   * @const
   */
  "enable": 1
};

/**
 * Allowed values for the <code>op</code> property.
 * @enum {String}
 * @readonly
 */
BulkUpdateAclEntry['OpEnum'] = {
  /**
   * value: "create"
   * @const
   */
  "create": "create",
  /**
   * value: "update"
   * @const
   */
  "update": "update",
  /**
   * value: "delete"
   * @const
   */
  "delete": "delete"
};
var _default = BulkUpdateAclEntry;
exports["default"] = _default;