"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _ConfigStoreItem = _interopRequireDefault(require("./ConfigStoreItem"));
var _ConfigStoreItemResponseAllOf = _interopRequireDefault(require("./ConfigStoreItemResponseAllOf"));
var _Timestamps = _interopRequireDefault(require("./Timestamps"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The ConfigStoreItemResponse model module.
 * @module model/ConfigStoreItemResponse
 * @version 7.0.0
 */
var ConfigStoreItemResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ConfigStoreItemResponse</code>.
   * @alias module:model/ConfigStoreItemResponse
   * @implements module:model/ConfigStoreItem
   * @implements module:model/Timestamps
   * @implements module:model/ConfigStoreItemResponseAllOf
   */
  function ConfigStoreItemResponse() {
    _classCallCheck(this, ConfigStoreItemResponse);
    _ConfigStoreItem["default"].initialize(this);
    _Timestamps["default"].initialize(this);
    _ConfigStoreItemResponseAllOf["default"].initialize(this);
    ConfigStoreItemResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(ConfigStoreItemResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>ConfigStoreItemResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ConfigStoreItemResponse} obj Optional instance to populate.
     * @return {module:model/ConfigStoreItemResponse} The populated <code>ConfigStoreItemResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ConfigStoreItemResponse();
        _ConfigStoreItem["default"].constructFromObject(data, obj);
        _Timestamps["default"].constructFromObject(data, obj);
        _ConfigStoreItemResponseAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('item_key')) {
          obj['item_key'] = _ApiClient["default"].convertToType(data['item_key'], 'String');
        }
        if (data.hasOwnProperty('item_value')) {
          obj['item_value'] = _ApiClient["default"].convertToType(data['item_value'], 'String');
        }
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }
        if (data.hasOwnProperty('deleted_at')) {
          obj['deleted_at'] = _ApiClient["default"].convertToType(data['deleted_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('store_id')) {
          obj['store_id'] = _ApiClient["default"].convertToType(data['store_id'], 'String');
        }
      }
      return obj;
    }
  }]);
  return ConfigStoreItemResponse;
}();
/**
 * Item key, maximum 256 characters.
 * @member {String} item_key
 */
ConfigStoreItemResponse.prototype['item_key'] = undefined;

/**
 * Item value, maximum 8000 characters.
 * @member {String} item_value
 */
ConfigStoreItemResponse.prototype['item_value'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
ConfigStoreItemResponse.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
ConfigStoreItemResponse.prototype['deleted_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
ConfigStoreItemResponse.prototype['updated_at'] = undefined;

/**
 * @member {String} store_id
 */
ConfigStoreItemResponse.prototype['store_id'] = undefined;

// Implement ConfigStoreItem interface:
/**
 * Item key, maximum 256 characters.
 * @member {String} item_key
 */
_ConfigStoreItem["default"].prototype['item_key'] = undefined;
/**
 * Item value, maximum 8000 characters.
 * @member {String} item_value
 */
_ConfigStoreItem["default"].prototype['item_value'] = undefined;
// Implement Timestamps interface:
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
_Timestamps["default"].prototype['created_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
_Timestamps["default"].prototype['deleted_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
_Timestamps["default"].prototype['updated_at'] = undefined;
// Implement ConfigStoreItemResponseAllOf interface:
/**
 * @member {String} store_id
 */
_ConfigStoreItemResponseAllOf["default"].prototype['store_id'] = undefined;
var _default = ConfigStoreItemResponse;
exports["default"] = _default;