"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _Contact = _interopRequireDefault(require("./Contact"));
var _ContactResponseAllOf = _interopRequireDefault(require("./ContactResponseAllOf"));
var _Timestamps = _interopRequireDefault(require("./Timestamps"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The ContactResponse model module.
 * @module model/ContactResponse
 * @version 7.0.0
 */
var ContactResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>ContactResponse</code>.
   * @alias module:model/ContactResponse
   * @implements module:model/Contact
   * @implements module:model/Timestamps
   * @implements module:model/ContactResponseAllOf
   */
  function ContactResponse() {
    _classCallCheck(this, ContactResponse);
    _Contact["default"].initialize(this);
    _Timestamps["default"].initialize(this);
    _ContactResponseAllOf["default"].initialize(this);
    ContactResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(ContactResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>ContactResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/ContactResponse} obj Optional instance to populate.
     * @return {module:model/ContactResponse} The populated <code>ContactResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new ContactResponse();
        _Contact["default"].constructFromObject(data, obj);
        _Timestamps["default"].constructFromObject(data, obj);
        _ContactResponseAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('user_id')) {
          obj['user_id'] = _ApiClient["default"].convertToType(data['user_id'], 'String');
        }
        if (data.hasOwnProperty('contact_type')) {
          obj['contact_type'] = _ApiClient["default"].convertToType(data['contact_type'], 'String');
        }
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('email')) {
          obj['email'] = _ApiClient["default"].convertToType(data['email'], 'String');
        }
        if (data.hasOwnProperty('phone')) {
          obj['phone'] = _ApiClient["default"].convertToType(data['phone'], 'String');
        }
        if (data.hasOwnProperty('customer_id')) {
          obj['customer_id'] = _ApiClient["default"].convertToType(data['customer_id'], 'String');
        }
        if (data.hasOwnProperty('created_at')) {
          obj['created_at'] = _ApiClient["default"].convertToType(data['created_at'], 'Date');
        }
        if (data.hasOwnProperty('deleted_at')) {
          obj['deleted_at'] = _ApiClient["default"].convertToType(data['deleted_at'], 'Date');
        }
        if (data.hasOwnProperty('updated_at')) {
          obj['updated_at'] = _ApiClient["default"].convertToType(data['updated_at'], 'Date');
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
      }
      return obj;
    }
  }]);
  return ContactResponse;
}();
/**
 * The alphanumeric string representing the user for this customer contact.
 * @member {String} user_id
 */
ContactResponse.prototype['user_id'] = undefined;

/**
 * The type of contact.
 * @member {module:model/ContactResponse.ContactTypeEnum} contact_type
 */
ContactResponse.prototype['contact_type'] = undefined;

/**
 * The name of this contact, when user_id is not provided.
 * @member {String} name
 */
ContactResponse.prototype['name'] = undefined;

/**
 * The email of this contact, when a user_id is not provided.
 * @member {String} email
 */
ContactResponse.prototype['email'] = undefined;

/**
 * The phone number for this contact. Required for primary, technical, and security contact types.
 * @member {String} phone
 */
ContactResponse.prototype['phone'] = undefined;

/**
 * The alphanumeric string representing the customer for this customer contact.
 * @member {String} customer_id
 */
ContactResponse.prototype['customer_id'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
ContactResponse.prototype['created_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
ContactResponse.prototype['deleted_at'] = undefined;

/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
ContactResponse.prototype['updated_at'] = undefined;

/**
 * @member {String} id
 */
ContactResponse.prototype['id'] = undefined;

// Implement Contact interface:
/**
 * The alphanumeric string representing the user for this customer contact.
 * @member {String} user_id
 */
_Contact["default"].prototype['user_id'] = undefined;
/**
 * The type of contact.
 * @member {module:model/Contact.ContactTypeEnum} contact_type
 */
_Contact["default"].prototype['contact_type'] = undefined;
/**
 * The name of this contact, when user_id is not provided.
 * @member {String} name
 */
_Contact["default"].prototype['name'] = undefined;
/**
 * The email of this contact, when a user_id is not provided.
 * @member {String} email
 */
_Contact["default"].prototype['email'] = undefined;
/**
 * The phone number for this contact. Required for primary, technical, and security contact types.
 * @member {String} phone
 */
_Contact["default"].prototype['phone'] = undefined;
/**
 * The alphanumeric string representing the customer for this customer contact.
 * @member {String} customer_id
 */
_Contact["default"].prototype['customer_id'] = undefined;
// Implement Timestamps interface:
/**
 * Date and time in ISO 8601 format.
 * @member {Date} created_at
 */
_Timestamps["default"].prototype['created_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} deleted_at
 */
_Timestamps["default"].prototype['deleted_at'] = undefined;
/**
 * Date and time in ISO 8601 format.
 * @member {Date} updated_at
 */
_Timestamps["default"].prototype['updated_at'] = undefined;
// Implement ContactResponseAllOf interface:
/**
 * @member {String} id
 */
_ContactResponseAllOf["default"].prototype['id'] = undefined;

/**
 * Allowed values for the <code>contact_type</code> property.
 * @enum {String}
 * @readonly
 */
ContactResponse['ContactTypeEnum'] = {
  /**
   * value: "primary"
   * @const
   */
  "primary": "primary",
  /**
   * value: "billing"
   * @const
   */
  "billing": "billing",
  /**
   * value: "technical"
   * @const
   */
  "technical": "technical",
  /**
   * value: "security"
   * @const
   */
  "security": "security",
  /**
   * value: "emergency"
   * @const
   */
  "emergency": "emergency",
  /**
   * value: "general compliance"
   * @const
   */
  "general compliance": "general compliance"
};
var _default = ContactResponse;
exports["default"] = _default;