"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The DictionaryInfoResponse model module.
 * @module model/DictionaryInfoResponse
 * @version 7.0.0
 */
var DictionaryInfoResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>DictionaryInfoResponse</code>.
   * @alias module:model/DictionaryInfoResponse
   */
  function DictionaryInfoResponse() {
    _classCallCheck(this, DictionaryInfoResponse);
    DictionaryInfoResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(DictionaryInfoResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>DictionaryInfoResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/DictionaryInfoResponse} obj Optional instance to populate.
     * @return {module:model/DictionaryInfoResponse} The populated <code>DictionaryInfoResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new DictionaryInfoResponse();
        if (data.hasOwnProperty('last_updated')) {
          obj['last_updated'] = _ApiClient["default"].convertToType(data['last_updated'], 'String');
        }
        if (data.hasOwnProperty('item_count')) {
          obj['item_count'] = _ApiClient["default"].convertToType(data['item_count'], 'Number');
        }
        if (data.hasOwnProperty('digest')) {
          obj['digest'] = _ApiClient["default"].convertToType(data['digest'], 'String');
        }
      }
      return obj;
    }
  }]);
  return DictionaryInfoResponse;
}();
/**
 * Timestamp (UTC) when the dictionary was last updated or an item was added or removed.
 * @member {String} last_updated
 */
DictionaryInfoResponse.prototype['last_updated'] = undefined;

/**
 * The number of items currently in the dictionary.
 * @member {Number} item_count
 */
DictionaryInfoResponse.prototype['item_count'] = undefined;

/**
 * A hash of all the dictionary content.
 * @member {String} digest
 */
DictionaryInfoResponse.prototype['digest'] = undefined;
var _default = DictionaryInfoResponse;
exports["default"] = _default;