"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _DomainInspectorMeasurements = _interopRequireDefault(require("./DomainInspectorMeasurements"));
var _RecordedTimestamp = _interopRequireDefault(require("./RecordedTimestamp"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The DomainInspectorRealtimeEntry model module.
 * @module model/DomainInspectorRealtimeEntry
 * @version 7.0.0
 */
var DomainInspectorRealtimeEntry = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>DomainInspectorRealtimeEntry</code>.
   * Each reporting period is represented by an entry in the &#x60;Data&#x60; property of the top level response and provides access to [measurement data](#measurements-data-model) for that time period, grouped in various ways: by domain name, domain IP address, and optionally by POP. The &#x60;datacenter&#x60; property organizes the measurements by Fastly POP, while the &#x60;aggregated&#x60; property combines the measurements of all POPs (but still splits by backend name and IP). 
   * @alias module:model/DomainInspectorRealtimeEntry
   */
  function DomainInspectorRealtimeEntry() {
    _classCallCheck(this, DomainInspectorRealtimeEntry);
    DomainInspectorRealtimeEntry.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(DomainInspectorRealtimeEntry, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>DomainInspectorRealtimeEntry</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/DomainInspectorRealtimeEntry} obj Optional instance to populate.
     * @return {module:model/DomainInspectorRealtimeEntry} The populated <code>DomainInspectorRealtimeEntry</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new DomainInspectorRealtimeEntry();
        if (data.hasOwnProperty('recorded')) {
          obj['recorded'] = _RecordedTimestamp["default"].constructFromObject(data['recorded']);
        }
        if (data.hasOwnProperty('aggregated')) {
          obj['aggregated'] = _ApiClient["default"].convertToType(data['aggregated'], {
            'String': _DomainInspectorMeasurements["default"]
          });
        }
        if (data.hasOwnProperty('datacenter')) {
          obj['datacenter'] = _ApiClient["default"].convertToType(data['datacenter'], {
            'String': {
              'String': _DomainInspectorMeasurements["default"]
            }
          });
        }
      }
      return obj;
    }
  }]);
  return DomainInspectorRealtimeEntry;
}();
/**
 * @member {module:model/RecordedTimestamp} recorded
 */
DomainInspectorRealtimeEntry.prototype['recorded'] = undefined;

/**
 * Groups [measurements](#measurements-data-model) by backend name and then by IP address.
 * @member {Object.<String, module:model/DomainInspectorMeasurements>} aggregated
 */
DomainInspectorRealtimeEntry.prototype['aggregated'] = undefined;

/**
 * Groups [measurements](#measurements-data-model) by POP, then backend name, and then IP address. See the [POPs API](/reference/api/utils/pops/) for details about POP identifiers.
 * @member {Object.<String, Object.<String, module:model/DomainInspectorMeasurements>>} datacenter
 */
DomainInspectorRealtimeEntry.prototype['datacenter'] = undefined;
var _default = DomainInspectorRealtimeEntry;
exports["default"] = _default;