"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The HistoricalDdosMeta model module.
 * @module model/HistoricalDdosMeta
 * @version 7.0.0
 */
var HistoricalDdosMeta = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>HistoricalDdosMeta</code>.
   * Meta information about the scope of the query in a human readable format.
   * @alias module:model/HistoricalDdosMeta
   */
  function HistoricalDdosMeta() {
    _classCallCheck(this, HistoricalDdosMeta);
    HistoricalDdosMeta.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(HistoricalDdosMeta, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>HistoricalDdosMeta</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/HistoricalDdosMeta} obj Optional instance to populate.
     * @return {module:model/HistoricalDdosMeta} The populated <code>HistoricalDdosMeta</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new HistoricalDdosMeta();
        if (data.hasOwnProperty('start')) {
          obj['start'] = _ApiClient["default"].convertToType(data['start'], 'String');
        }
        if (data.hasOwnProperty('end')) {
          obj['end'] = _ApiClient["default"].convertToType(data['end'], 'String');
        }
        if (data.hasOwnProperty('downsample')) {
          obj['downsample'] = _ApiClient["default"].convertToType(data['downsample'], 'String');
        }
        if (data.hasOwnProperty('metric')) {
          obj['metric'] = _ApiClient["default"].convertToType(data['metric'], 'String');
        }
      }
      return obj;
    }
  }]);
  return HistoricalDdosMeta;
}();
/**
 * Start time that was used to perform the query as an ISO-8601-formatted date and time.
 * @member {String} start
 */
HistoricalDdosMeta.prototype['start'] = undefined;

/**
 * End time that was used to perform the query as an ISO-8601-formatted date and time.
 * @member {String} end
 */
HistoricalDdosMeta.prototype['end'] = undefined;

/**
 * Downsample that was used to perform the query. One of `hour` or `day`.
 * @member {String} downsample
 */
HistoricalDdosMeta.prototype['downsample'] = undefined;

/**
 * A comma-separated list of the metrics that were requested.
 * @member {String} metric
 */
HistoricalDdosMeta.prototype['metric'] = undefined;
var _default = HistoricalDdosMeta;
exports["default"] = _default;