"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _HistoricalOriginsResponseAllOf = _interopRequireDefault(require("./HistoricalOriginsResponseAllOf"));
var _OriginInspectorEntry = _interopRequireDefault(require("./OriginInspectorEntry"));
var _OriginInspectorHistorical = _interopRequireDefault(require("./OriginInspectorHistorical"));
var _OriginInspectorHistoricalMeta = _interopRequireDefault(require("./OriginInspectorHistoricalMeta"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The HistoricalOriginsResponse model module.
 * @module model/HistoricalOriginsResponse
 * @version 7.0.0
 */
var HistoricalOriginsResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>HistoricalOriginsResponse</code>.
   * @alias module:model/HistoricalOriginsResponse
   * @implements module:model/OriginInspectorHistorical
   * @implements module:model/HistoricalOriginsResponseAllOf
   */
  function HistoricalOriginsResponse() {
    _classCallCheck(this, HistoricalOriginsResponse);
    _OriginInspectorHistorical["default"].initialize(this);
    _HistoricalOriginsResponseAllOf["default"].initialize(this);
    HistoricalOriginsResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(HistoricalOriginsResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>HistoricalOriginsResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/HistoricalOriginsResponse} obj Optional instance to populate.
     * @return {module:model/HistoricalOriginsResponse} The populated <code>HistoricalOriginsResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new HistoricalOriginsResponse();
        _OriginInspectorHistorical["default"].constructFromObject(data, obj);
        _HistoricalOriginsResponseAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('status')) {
          obj['status'] = _ApiClient["default"].convertToType(data['status'], 'String');
        }
        if (data.hasOwnProperty('meta')) {
          obj['meta'] = _OriginInspectorHistoricalMeta["default"].constructFromObject(data['meta']);
        }
        if (data.hasOwnProperty('msg')) {
          obj['msg'] = _ApiClient["default"].convertToType(data['msg'], 'String');
        }
        if (data.hasOwnProperty('data')) {
          obj['data'] = _ApiClient["default"].convertToType(data['data'], [_OriginInspectorEntry["default"]]);
        }
      }
      return obj;
    }
  }]);
  return HistoricalOriginsResponse;
}();
/**
 * Whether or not we were able to successfully execute the query.
 * @member {String} status
 */
HistoricalOriginsResponse.prototype['status'] = undefined;

/**
 * @member {module:model/OriginInspectorHistoricalMeta} meta
 */
HistoricalOriginsResponse.prototype['meta'] = undefined;

/**
 * If the query was not successful, this will provide a string that explains why.
 * @member {String} msg
 */
HistoricalOriginsResponse.prototype['msg'] = undefined;

/**
 * A list of timeseries. Each individual timeseries represents a unique combination of dimensions, such as origin host, region or POP.
 * @member {Array.<module:model/OriginInspectorEntry>} data
 */
HistoricalOriginsResponse.prototype['data'] = undefined;

// Implement OriginInspectorHistorical interface:
/**
 * Whether or not we were able to successfully execute the query.
 * @member {String} status
 */
_OriginInspectorHistorical["default"].prototype['status'] = undefined;
/**
 * @member {module:model/OriginInspectorHistoricalMeta} meta
 */
_OriginInspectorHistorical["default"].prototype['meta'] = undefined;
/**
 * If the query was not successful, this will provide a string that explains why.
 * @member {String} msg
 */
_OriginInspectorHistorical["default"].prototype['msg'] = undefined;
/**
 * A list of [entries](#entry-data-model), each representing one unique combination of dimensions, such as origin host, region or POP.
 * @member {Array.<module:model/OriginInspectorHistoricalData>} data
 */
_OriginInspectorHistorical["default"].prototype['data'] = undefined;
// Implement HistoricalOriginsResponseAllOf interface:
/**
 * A list of timeseries. Each individual timeseries represents a unique combination of dimensions, such as origin host, region or POP.
 * @member {Array.<module:model/OriginInspectorEntry>} data
 */
_HistoricalOriginsResponseAllOf["default"].prototype['data'] = undefined;
var _default = HistoricalOriginsResponse;
exports["default"] = _default;