"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _Historical = _interopRequireDefault(require("./Historical"));
var _HistoricalMeta = _interopRequireDefault(require("./HistoricalMeta"));
var _HistoricalRegionsResponseAllOf = _interopRequireDefault(require("./HistoricalRegionsResponseAllOf"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The HistoricalRegionsResponse model module.
 * @module model/HistoricalRegionsResponse
 * @version 7.0.0
 */
var HistoricalRegionsResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>HistoricalRegionsResponse</code>.
   * @alias module:model/HistoricalRegionsResponse
   * @implements module:model/Historical
   * @implements module:model/HistoricalRegionsResponseAllOf
   */
  function HistoricalRegionsResponse() {
    _classCallCheck(this, HistoricalRegionsResponse);
    _Historical["default"].initialize(this);
    _HistoricalRegionsResponseAllOf["default"].initialize(this);
    HistoricalRegionsResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(HistoricalRegionsResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>HistoricalRegionsResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/HistoricalRegionsResponse} obj Optional instance to populate.
     * @return {module:model/HistoricalRegionsResponse} The populated <code>HistoricalRegionsResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new HistoricalRegionsResponse();
        _Historical["default"].constructFromObject(data, obj);
        _HistoricalRegionsResponseAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('status')) {
          obj['status'] = _ApiClient["default"].convertToType(data['status'], 'String');
        }
        if (data.hasOwnProperty('meta')) {
          obj['meta'] = _HistoricalMeta["default"].constructFromObject(data['meta']);
        }
        if (data.hasOwnProperty('msg')) {
          obj['msg'] = _ApiClient["default"].convertToType(data['msg'], 'String');
        }
        if (data.hasOwnProperty('data')) {
          obj['data'] = _ApiClient["default"].convertToType(data['data'], ['String']);
        }
      }
      return obj;
    }
  }]);
  return HistoricalRegionsResponse;
}();
/**
 * Whether or not we were able to successfully execute the query.
 * @member {String} status
 */
HistoricalRegionsResponse.prototype['status'] = undefined;

/**
 * @member {module:model/HistoricalMeta} meta
 */
HistoricalRegionsResponse.prototype['meta'] = undefined;

/**
 * If the query was not successful, this will provide a string that explains why.
 * @member {String} msg
 */
HistoricalRegionsResponse.prototype['msg'] = undefined;

/**
 * @member {Array.<String>} data
 */
HistoricalRegionsResponse.prototype['data'] = undefined;

// Implement Historical interface:
/**
 * Whether or not we were able to successfully execute the query.
 * @member {String} status
 */
_Historical["default"].prototype['status'] = undefined;
/**
 * @member {module:model/HistoricalMeta} meta
 */
_Historical["default"].prototype['meta'] = undefined;
/**
 * If the query was not successful, this will provide a string that explains why.
 * @member {String} msg
 */
_Historical["default"].prototype['msg'] = undefined;
// Implement HistoricalRegionsResponseAllOf interface:
/**
 * @member {Array.<String>} data
 */
_HistoricalRegionsResponseAllOf["default"].prototype['data'] = undefined;
var _default = HistoricalRegionsResponse;
exports["default"] = _default;