"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _ReadOnlyServiceId = _interopRequireDefault(require("./ReadOnlyServiceId"));
var _ReadOnlyVersion = _interopRequireDefault(require("./ReadOnlyVersion"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The LegacyWafFirewall model module.
 * @module model/LegacyWafFirewall
 * @version 7.0.0
 */
var LegacyWafFirewall = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>LegacyWafFirewall</code>.
   * @alias module:model/LegacyWafFirewall
   */
  function LegacyWafFirewall() {
    _classCallCheck(this, LegacyWafFirewall);
    LegacyWafFirewall.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(LegacyWafFirewall, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>LegacyWafFirewall</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/LegacyWafFirewall} obj Optional instance to populate.
     * @return {module:model/LegacyWafFirewall} The populated <code>LegacyWafFirewall</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new LegacyWafFirewall();
        if (data.hasOwnProperty('last_push')) {
          obj['last_push'] = _ApiClient["default"].convertToType(data['last_push'], 'String');
        }
        if (data.hasOwnProperty('prefetch_condition')) {
          obj['prefetch_condition'] = _ApiClient["default"].convertToType(data['prefetch_condition'], 'String');
        }
        if (data.hasOwnProperty('response')) {
          obj['response'] = _ApiClient["default"].convertToType(data['response'], 'String');
        }
        if (data.hasOwnProperty('version')) {
          obj['version'] = _ReadOnlyVersion["default"].constructFromObject(data['version']);
        }
        if (data.hasOwnProperty('service_id')) {
          obj['service_id'] = _ReadOnlyServiceId["default"].constructFromObject(data['service_id']);
        }
        if (data.hasOwnProperty('disabled')) {
          obj['disabled'] = _ApiClient["default"].convertToType(data['disabled'], 'Boolean');
        }
        if (data.hasOwnProperty('rule_statuses_log_count')) {
          obj['rule_statuses_log_count'] = _ApiClient["default"].convertToType(data['rule_statuses_log_count'], 'Number');
        }
        if (data.hasOwnProperty('rule_statuses_block_count')) {
          obj['rule_statuses_block_count'] = _ApiClient["default"].convertToType(data['rule_statuses_block_count'], 'Number');
        }
        if (data.hasOwnProperty('rule_statuses_disabled_count')) {
          obj['rule_statuses_disabled_count'] = _ApiClient["default"].convertToType(data['rule_statuses_disabled_count'], 'Number');
        }
      }
      return obj;
    }
  }]);
  return LegacyWafFirewall;
}();
/**
 * Date and time that VCL was last pushed to cache nodes.
 * @member {String} last_push
 */
LegacyWafFirewall.prototype['last_push'] = undefined;

/**
 * Name of the corresponding condition object.
 * @member {String} prefetch_condition
 */
LegacyWafFirewall.prototype['prefetch_condition'] = undefined;

/**
 * Name of the corresponding response object.
 * @member {String} response
 */
LegacyWafFirewall.prototype['response'] = undefined;

/**
 * @member {module:model/ReadOnlyVersion} version
 */
LegacyWafFirewall.prototype['version'] = undefined;

/**
 * @member {module:model/ReadOnlyServiceId} service_id
 */
LegacyWafFirewall.prototype['service_id'] = undefined;

/**
 * The status of the firewall.
 * @member {Boolean} disabled
 * @default false
 */
LegacyWafFirewall.prototype['disabled'] = false;

/**
 * The number of rule statuses set to log.
 * @member {Number} rule_statuses_log_count
 */
LegacyWafFirewall.prototype['rule_statuses_log_count'] = undefined;

/**
 * The number of rule statuses set to block.
 * @member {Number} rule_statuses_block_count
 */
LegacyWafFirewall.prototype['rule_statuses_block_count'] = undefined;

/**
 * The number of rule statuses set to disabled.
 * @member {Number} rule_statuses_disabled_count
 */
LegacyWafFirewall.prototype['rule_statuses_disabled_count'] = undefined;
var _default = LegacyWafFirewall;
exports["default"] = _default;