"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The PoolResponseCommon model module.
 * @module model/PoolResponseCommon
 * @version 7.0.0
 */
var PoolResponseCommon = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>PoolResponseCommon</code>.
   * @alias module:model/PoolResponseCommon
   */
  function PoolResponseCommon() {
    _classCallCheck(this, PoolResponseCommon);
    PoolResponseCommon.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(PoolResponseCommon, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>PoolResponseCommon</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/PoolResponseCommon} obj Optional instance to populate.
     * @return {module:model/PoolResponseCommon} The populated <code>PoolResponseCommon</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new PoolResponseCommon();
        if (data.hasOwnProperty('between_bytes_timeout')) {
          obj['between_bytes_timeout'] = _ApiClient["default"].convertToType(data['between_bytes_timeout'], 'String');
        }
        if (data.hasOwnProperty('connect_timeout')) {
          obj['connect_timeout'] = _ApiClient["default"].convertToType(data['connect_timeout'], 'String');
        }
        if (data.hasOwnProperty('first_byte_timeout')) {
          obj['first_byte_timeout'] = _ApiClient["default"].convertToType(data['first_byte_timeout'], 'String');
        }
        if (data.hasOwnProperty('max_conn_default')) {
          obj['max_conn_default'] = _ApiClient["default"].convertToType(data['max_conn_default'], 'String');
        }
        if (data.hasOwnProperty('tls_check_cert')) {
          obj['tls_check_cert'] = _ApiClient["default"].convertToType(data['tls_check_cert'], 'String');
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
      }
      return obj;
    }
  }]);
  return PoolResponseCommon;
}();
/**
 * Maximum duration in milliseconds that Fastly will wait while receiving no data on a download from a backend. If exceeded, the response received so far will be considered complete and the fetch will end. May be set at runtime using `bereq.between_bytes_timeout`.
 * @member {String} between_bytes_timeout
 */
PoolResponseCommon.prototype['between_bytes_timeout'] = undefined;

/**
 * How long to wait for a timeout in milliseconds.
 * @member {String} connect_timeout
 */
PoolResponseCommon.prototype['connect_timeout'] = undefined;

/**
 * How long to wait for the first byte in milliseconds.
 * @member {String} first_byte_timeout
 */
PoolResponseCommon.prototype['first_byte_timeout'] = undefined;

/**
 * Maximum number of connections.
 * @member {String} max_conn_default
 * @default '200'
 */
PoolResponseCommon.prototype['max_conn_default'] = '200';

/**
 * Be strict on checking TLS certs.
 * @member {String} tls_check_cert
 */
PoolResponseCommon.prototype['tls_check_cert'] = undefined;

/**
 * @member {String} id
 */
PoolResponseCommon.prototype['id'] = undefined;
var _default = PoolResponseCommon;
exports["default"] = _default;