"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The RequestSettingsResponseAllOf model module.
 * @module model/RequestSettingsResponseAllOf
 * @version 7.0.0
 */
var RequestSettingsResponseAllOf = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>RequestSettingsResponseAllOf</code>.
   * @alias module:model/RequestSettingsResponseAllOf
   */
  function RequestSettingsResponseAllOf() {
    _classCallCheck(this, RequestSettingsResponseAllOf);
    RequestSettingsResponseAllOf.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(RequestSettingsResponseAllOf, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>RequestSettingsResponseAllOf</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/RequestSettingsResponseAllOf} obj Optional instance to populate.
     * @return {module:model/RequestSettingsResponseAllOf} The populated <code>RequestSettingsResponseAllOf</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new RequestSettingsResponseAllOf();
        if (data.hasOwnProperty('bypass_busy_wait')) {
          obj['bypass_busy_wait'] = _ApiClient["default"].convertToType(data['bypass_busy_wait'], 'String');
        }
        if (data.hasOwnProperty('force_miss')) {
          obj['force_miss'] = _ApiClient["default"].convertToType(data['force_miss'], 'String');
        }
        if (data.hasOwnProperty('force_ssl')) {
          obj['force_ssl'] = _ApiClient["default"].convertToType(data['force_ssl'], 'String');
        }
        if (data.hasOwnProperty('geo_headers')) {
          obj['geo_headers'] = _ApiClient["default"].convertToType(data['geo_headers'], 'String');
        }
        if (data.hasOwnProperty('max_stale_age')) {
          obj['max_stale_age'] = _ApiClient["default"].convertToType(data['max_stale_age'], 'String');
        }
        if (data.hasOwnProperty('timer_support')) {
          obj['timer_support'] = _ApiClient["default"].convertToType(data['timer_support'], 'String');
        }
      }
      return obj;
    }
  }]);
  return RequestSettingsResponseAllOf;
}();
/**
 * Disable collapsed forwarding, so you don't wait for other objects to origin.
 * @member {String} bypass_busy_wait
 */
RequestSettingsResponseAllOf.prototype['bypass_busy_wait'] = undefined;

/**
 * Allows you to force a cache miss for the request. Replaces the item in the cache if the content is cacheable.
 * @member {String} force_miss
 */
RequestSettingsResponseAllOf.prototype['force_miss'] = undefined;

/**
 * Forces the request use SSL (redirects a non-SSL to SSL).
 * @member {String} force_ssl
 */
RequestSettingsResponseAllOf.prototype['force_ssl'] = undefined;

/**
 * Injects Fastly-Geo-Country, Fastly-Geo-City, and Fastly-Geo-Region into the request headers.
 * @member {String} geo_headers
 */
RequestSettingsResponseAllOf.prototype['geo_headers'] = undefined;

/**
 * How old an object is allowed to be to serve stale-if-error or stale-while-revalidate.
 * @member {String} max_stale_age
 */
RequestSettingsResponseAllOf.prototype['max_stale_age'] = undefined;

/**
 * Injects the X-Timer info into the request for viewing origin fetch durations.
 * @member {String} timer_support
 */
RequestSettingsResponseAllOf.prototype['timer_support'] = undefined;
var _default = RequestSettingsResponseAllOf;
exports["default"] = _default;