"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _SnippetCommon = _interopRequireDefault(require("./SnippetCommon"));
var _SnippetWithDynamicNumberAllOf = _interopRequireDefault(require("./SnippetWithDynamicNumberAllOf"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The SnippetWithDynamicNumber model module.
 * @module model/SnippetWithDynamicNumber
 * @version 7.0.0
 */
var SnippetWithDynamicNumber = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>SnippetWithDynamicNumber</code>.
   * @alias module:model/SnippetWithDynamicNumber
   * @implements module:model/SnippetCommon
   * @implements module:model/SnippetWithDynamicNumberAllOf
   */
  function SnippetWithDynamicNumber() {
    _classCallCheck(this, SnippetWithDynamicNumber);
    _SnippetCommon["default"].initialize(this);
    _SnippetWithDynamicNumberAllOf["default"].initialize(this);
    SnippetWithDynamicNumber.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(SnippetWithDynamicNumber, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>SnippetWithDynamicNumber</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/SnippetWithDynamicNumber} obj Optional instance to populate.
     * @return {module:model/SnippetWithDynamicNumber} The populated <code>SnippetWithDynamicNumber</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new SnippetWithDynamicNumber();
        _SnippetCommon["default"].constructFromObject(data, obj);
        _SnippetWithDynamicNumberAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('name')) {
          obj['name'] = _ApiClient["default"].convertToType(data['name'], 'String');
        }
        if (data.hasOwnProperty('type')) {
          obj['type'] = _ApiClient["default"].convertToType(data['type'], 'String');
        }
        if (data.hasOwnProperty('content')) {
          obj['content'] = _ApiClient["default"].convertToType(data['content'], 'String');
        }
        if (data.hasOwnProperty('priority')) {
          obj['priority'] = _ApiClient["default"].convertToType(data['priority'], 'String');
        }
        if (data.hasOwnProperty('dynamic')) {
          obj['dynamic'] = _ApiClient["default"].convertToType(data['dynamic'], 'Number');
        }
      }
      return obj;
    }
  }]);
  return SnippetWithDynamicNumber;
}();
/**
 * The name for the snippet.
 * @member {String} name
 */
SnippetWithDynamicNumber.prototype['name'] = undefined;

/**
 * The location in generated VCL where the snippet should be placed.
 * @member {module:model/SnippetWithDynamicNumber.TypeEnum} type
 */
SnippetWithDynamicNumber.prototype['type'] = undefined;

/**
 * The VCL code that specifies exactly what the snippet does.
 * @member {String} content
 */
SnippetWithDynamicNumber.prototype['content'] = undefined;

/**
 * Priority determines execution order. Lower numbers execute first.
 * @member {String} priority
 * @default '100'
 */
SnippetWithDynamicNumber.prototype['priority'] = '100';

/**
 * Sets the snippet version.
 * @member {module:model/SnippetWithDynamicNumber.DynamicEnum} dynamic
 */
SnippetWithDynamicNumber.prototype['dynamic'] = undefined;

// Implement SnippetCommon interface:
/**
 * The name for the snippet.
 * @member {String} name
 */
_SnippetCommon["default"].prototype['name'] = undefined;
/**
 * The location in generated VCL where the snippet should be placed.
 * @member {module:model/SnippetCommon.TypeEnum} type
 */
_SnippetCommon["default"].prototype['type'] = undefined;
/**
 * The VCL code that specifies exactly what the snippet does.
 * @member {String} content
 */
_SnippetCommon["default"].prototype['content'] = undefined;
/**
 * Priority determines execution order. Lower numbers execute first.
 * @member {String} priority
 * @default '100'
 */
_SnippetCommon["default"].prototype['priority'] = '100';
// Implement SnippetWithDynamicNumberAllOf interface:
/**
 * Sets the snippet version.
 * @member {module:model/SnippetWithDynamicNumberAllOf.DynamicEnum} dynamic
 */
_SnippetWithDynamicNumberAllOf["default"].prototype['dynamic'] = undefined;

/**
 * Allowed values for the <code>type</code> property.
 * @enum {String}
 * @readonly
 */
SnippetWithDynamicNumber['TypeEnum'] = {
  /**
   * value: "init"
   * @const
   */
  "init": "init",
  /**
   * value: "recv"
   * @const
   */
  "recv": "recv",
  /**
   * value: "hash"
   * @const
   */
  "hash": "hash",
  /**
   * value: "hit"
   * @const
   */
  "hit": "hit",
  /**
   * value: "miss"
   * @const
   */
  "miss": "miss",
  /**
   * value: "pass"
   * @const
   */
  "pass": "pass",
  /**
   * value: "fetch"
   * @const
   */
  "fetch": "fetch",
  /**
   * value: "error"
   * @const
   */
  "error": "error",
  /**
   * value: "deliver"
   * @const
   */
  "deliver": "deliver",
  /**
   * value: "log"
   * @const
   */
  "log": "log",
  /**
   * value: "none"
   * @const
   */
  "none": "none"
};

/**
 * Allowed values for the <code>dynamic</code> property.
 * @enum {Number}
 * @readonly
 */
SnippetWithDynamicNumber['DynamicEnum'] = {
  /**
   * value: 0
   * @const
   */
  "regular": 0,
  /**
   * value: 1
   * @const
   */
  "dynamic": 1
};
var _default = SnippetWithDynamicNumber;
exports["default"] = _default;