"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _TlsCommonResponseAllOf = _interopRequireDefault(require("./TlsCommonResponseAllOf"));
var _TlsCommonResponseAllOf2 = _interopRequireDefault(require("./TlsCommonResponseAllOf1"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The TlsCommonResponse model module.
 * @module model/TlsCommonResponse
 * @version 7.0.0
 */
var TlsCommonResponse = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>TlsCommonResponse</code>.
   * @alias module:model/TlsCommonResponse
   * @implements module:model/TlsCommonResponseAllOf
   * @implements module:model/TlsCommonResponseAllOf1
   */
  function TlsCommonResponse() {
    _classCallCheck(this, TlsCommonResponse);
    _TlsCommonResponseAllOf["default"].initialize(this);
    _TlsCommonResponseAllOf2["default"].initialize(this);
    TlsCommonResponse.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(TlsCommonResponse, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>TlsCommonResponse</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/TlsCommonResponse} obj Optional instance to populate.
     * @return {module:model/TlsCommonResponse} The populated <code>TlsCommonResponse</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new TlsCommonResponse();
        _TlsCommonResponseAllOf["default"].constructFromObject(data, obj);
        _TlsCommonResponseAllOf2["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('tls_ca_cert')) {
          obj['tls_ca_cert'] = _ApiClient["default"].convertToType(data['tls_ca_cert'], 'String');
        }
        if (data.hasOwnProperty('tls_client_cert')) {
          obj['tls_client_cert'] = _ApiClient["default"].convertToType(data['tls_client_cert'], 'String');
        }
        if (data.hasOwnProperty('tls_client_key')) {
          obj['tls_client_key'] = _ApiClient["default"].convertToType(data['tls_client_key'], 'String');
        }
        if (data.hasOwnProperty('tls_cert_hostname')) {
          obj['tls_cert_hostname'] = _ApiClient["default"].convertToType(data['tls_cert_hostname'], 'String');
        }
        if (data.hasOwnProperty('use_tls')) {
          obj['use_tls'] = _ApiClient["default"].convertToType(data['use_tls'], 'String');
        }
      }
      return obj;
    }
  }]);
  return TlsCommonResponse;
}();
/**
 * A secure certificate to authenticate a server with. Must be in PEM format.
 * @member {String} tls_ca_cert
 * @default 'null'
 */
TlsCommonResponse.prototype['tls_ca_cert'] = 'null';

/**
 * The client certificate used to make authenticated requests. Must be in PEM format.
 * @member {String} tls_client_cert
 * @default 'null'
 */
TlsCommonResponse.prototype['tls_client_cert'] = 'null';

/**
 * The client private key used to make authenticated requests. Must be in PEM format.
 * @member {String} tls_client_key
 * @default 'null'
 */
TlsCommonResponse.prototype['tls_client_key'] = 'null';

/**
 * The hostname used to verify a server's certificate. It can either be the Common Name (CN) or a Subject Alternative Name (SAN).
 * @member {String} tls_cert_hostname
 * @default 'null'
 */
TlsCommonResponse.prototype['tls_cert_hostname'] = 'null';

/**
 * Whether to use TLS.
 * @member {module:model/TlsCommonResponse.UseTlsEnum} use_tls
 * @default '0'
 */
TlsCommonResponse.prototype['use_tls'] = undefined;

// Implement TlsCommonResponseAllOf interface:
/**
 * A secure certificate to authenticate a server with. Must be in PEM format.
 * @member {String} tls_ca_cert
 * @default 'null'
 */
_TlsCommonResponseAllOf["default"].prototype['tls_ca_cert'] = 'null';
/**
 * The client certificate used to make authenticated requests. Must be in PEM format.
 * @member {String} tls_client_cert
 * @default 'null'
 */
_TlsCommonResponseAllOf["default"].prototype['tls_client_cert'] = 'null';
/**
 * The client private key used to make authenticated requests. Must be in PEM format.
 * @member {String} tls_client_key
 * @default 'null'
 */
_TlsCommonResponseAllOf["default"].prototype['tls_client_key'] = 'null';
/**
 * The hostname used to verify a server's certificate. It can either be the Common Name (CN) or a Subject Alternative Name (SAN).
 * @member {String} tls_cert_hostname
 * @default 'null'
 */
_TlsCommonResponseAllOf["default"].prototype['tls_cert_hostname'] = 'null';
// Implement TlsCommonResponseAllOf1 interface:
/**
 * Whether to use TLS.
 * @member {module:model/TlsCommonResponseAllOf1.UseTlsEnum} use_tls
 * @default '0'
 */
_TlsCommonResponseAllOf2["default"].prototype['use_tls'] = undefined;

/**
 * Allowed values for the <code>use_tls</code> property.
 * @enum {String}
 * @readonly
 */
TlsCommonResponse['UseTlsEnum'] = {
  /**
   * value: "0"
   * @const
   */
  "no_tls": "0",
  /**
   * value: "1"
   * @const
   */
  "use_tls": "1"
};
var _default = TlsCommonResponse;
exports["default"] = _default;