"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _ApiClient = _interopRequireDefault(require("../ApiClient"));
var _RelationshipWafRule = _interopRequireDefault(require("./RelationshipWafRule"));
var _TypeWafRuleRevision = _interopRequireDefault(require("./TypeWafRuleRevision"));
var _WafRuleRevision = _interopRequireDefault(require("./WafRuleRevision"));
var _WafRuleRevisionAttributes = _interopRequireDefault(require("./WafRuleRevisionAttributes"));
var _WafRuleRevisionResponseDataAllOf = _interopRequireDefault(require("./WafRuleRevisionResponseDataAllOf"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); } /**
 * Fastly API
 * Via the Fastly API you can perform any of the operations that are possible within the management console,  including creating services, domains, and backends, configuring rules or uploading your own application code, as well as account operations such as user administration and billing reports. The API is organized into collections of endpoints that allow manipulation of objects related to Fastly services and accounts. For the most accurate and up-to-date API reference content, visit our [Developer Hub](https://developer.fastly.com/reference/api/) 
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: oss@fastly.com
 *
 * NOTE: This class is auto generated.
 * Do not edit the class manually.
 *
 */
/**
 * The WafRuleRevisionResponseData model module.
 * @module model/WafRuleRevisionResponseData
 * @version 7.0.0
 */
var WafRuleRevisionResponseData = /*#__PURE__*/function () {
  /**
   * Constructs a new <code>WafRuleRevisionResponseData</code>.
   * @alias module:model/WafRuleRevisionResponseData
   * @implements module:model/WafRuleRevision
   * @implements module:model/WafRuleRevisionResponseDataAllOf
   */
  function WafRuleRevisionResponseData() {
    _classCallCheck(this, WafRuleRevisionResponseData);
    _WafRuleRevision["default"].initialize(this);
    _WafRuleRevisionResponseDataAllOf["default"].initialize(this);
    WafRuleRevisionResponseData.initialize(this);
  }

  /**
   * Initializes the fields of this object.
   * This method is used by the constructors of any subclasses, in order to implement multiple inheritance (mix-ins).
   * Only for internal use.
   */
  _createClass(WafRuleRevisionResponseData, null, [{
    key: "initialize",
    value: function initialize(obj) {}

    /**
     * Constructs a <code>WafRuleRevisionResponseData</code> from a plain JavaScript object, optionally creating a new instance.
     * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
     * @param {Object} data The plain JavaScript object bearing properties of interest.
     * @param {module:model/WafRuleRevisionResponseData} obj Optional instance to populate.
     * @return {module:model/WafRuleRevisionResponseData} The populated <code>WafRuleRevisionResponseData</code> instance.
     */
  }, {
    key: "constructFromObject",
    value: function constructFromObject(data, obj) {
      if (data) {
        obj = obj || new WafRuleRevisionResponseData();
        _WafRuleRevision["default"].constructFromObject(data, obj);
        _WafRuleRevisionResponseDataAllOf["default"].constructFromObject(data, obj);
        if (data.hasOwnProperty('type')) {
          obj['type'] = _TypeWafRuleRevision["default"].constructFromObject(data['type']);
        }
        if (data.hasOwnProperty('id')) {
          obj['id'] = _ApiClient["default"].convertToType(data['id'], 'String');
        }
        if (data.hasOwnProperty('attributes')) {
          obj['attributes'] = _WafRuleRevisionAttributes["default"].constructFromObject(data['attributes']);
        }
        if (data.hasOwnProperty('relationships')) {
          obj['relationships'] = _RelationshipWafRule["default"].constructFromObject(data['relationships']);
        }
      }
      return obj;
    }
  }]);
  return WafRuleRevisionResponseData;
}();
/**
 * @member {module:model/TypeWafRuleRevision} type
 */
WafRuleRevisionResponseData.prototype['type'] = undefined;

/**
 * Alphanumeric string identifying a WAF rule revision.
 * @member {String} id
 */
WafRuleRevisionResponseData.prototype['id'] = undefined;

/**
 * @member {module:model/WafRuleRevisionAttributes} attributes
 */
WafRuleRevisionResponseData.prototype['attributes'] = undefined;

/**
 * @member {module:model/RelationshipWafRule} relationships
 */
WafRuleRevisionResponseData.prototype['relationships'] = undefined;

// Implement WafRuleRevision interface:
/**
 * @member {module:model/TypeWafRuleRevision} type
 */
_WafRuleRevision["default"].prototype['type'] = undefined;
/**
 * Alphanumeric string identifying a WAF rule revision.
 * @member {String} id
 */
_WafRuleRevision["default"].prototype['id'] = undefined;
/**
 * @member {module:model/WafRuleRevisionAttributes} attributes
 */
_WafRuleRevision["default"].prototype['attributes'] = undefined;
// Implement WafRuleRevisionResponseDataAllOf interface:
/**
 * @member {module:model/RelationshipWafRule} relationships
 */
_WafRuleRevisionResponseDataAllOf["default"].prototype['relationships'] = undefined;
var _default = WafRuleRevisionResponseData;
exports["default"] = _default;